"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Box2DBody = void 0;
const b2PolygonShape_1 = require("@thats/box2d/Collision/Shapes/b2PolygonShape");
const react_1 = __importDefault(require("react"));
function Box2DBody(props) {
    const { body } = props;
    const fixtures = [];
    let fixture = body.GetFixtureList();
    while (fixture) {
        fixtures.push(fixture);
        fixture = fixture.GetNext();
    }
    setFixturePaths(body, fixtures);
    return (react_1.default.createElement("g", null, fixtures.map((fixture, idx) => (react_1.default.createElement("path", { key: 'f_' + idx, d: fixture.m_userData.path, className: fixture.m_userData.class })))));
}
exports.Box2DBody = Box2DBody;
exports.default = Box2DBody;
function fixturePath(body, fixture) {
    let path = '', shape = fixture.m_shape;
    if (shape instanceof b2PolygonShape_1.B2PolygonShape) {
        const polyShape = shape;
        polyShape.m_vertices.forEach((v, i) => {
            if (i < polyShape.m_count) {
                const vw = body.GetWorldPoint(v);
                path += '' + (i === 0 ? 'M ' : 'L ') + vw.x + ' ' + vw.y + ' ';
            }
        });
        path +=
            'L ' +
                body.GetWorldPoint(polyShape.m_vertices[0]).x +
                ' ' +
                body.GetWorldPoint(polyShape.m_vertices[0]).y;
    }
    return path;
}
function setFixturePaths(body, fixtures) {
    if (body.IsAwake()) {
        fixtures.forEach(fixture => {
            fixture.m_userData.path = fixturePath(body, fixture);
        });
    }
}
//# sourceMappingURL=Box2DBody.js.map